HavenLootsFrames = {};

function HavenLootsFrames.CreateNiceBar(newInstance)
	newInstance.Background = CreateFrame("statusbar", newInstance:GetName() .."_Background", newInstance, nil);
	newInstance.Bar = CreateFrame("Frame", newInstance:GetName() .."_Bar", newInstance, nil);
	newInstance.BarTexture = newInstance.Bar:CreateTexture(nil, "LOW");
	newInstance.Text = newInstance.Bar:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	newInstance.ObjectType = "Bar";
	return newInstance
end

function HavenLootsFrames.CreateNiceFrame(newInstance)
	newInstance.Background = CreateFrame("Frame", newInstance:GetName() .."_Background", newInstance, nil);
	newInstance.BackgroundTexture = newInstance.Background:CreateTexture(nil, "BACKGROUND");
	newInstance.Bar = CreateFrame("Frame", newInstance:GetName() .."_Bar", newInstance, nil);
	newInstance.BarTexture = newInstance.Bar:CreateTexture(nil, "LOW");
	newInstance.Text = newInstance.Bar:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	newInstance.ObjectType = "Frame";
	return newInstance
end

function HavenLootsFrames.PositionFrames(frame, point, anchor, relativePoint, width, height, xpos, ypos)
	frame:SetSize(width, height);
	frame:SetPoint(point, anchor, relativePoint, xpos, ypos);

	frame.Background:SetFrameStrata("BACKGROUND");
	frame.Background:SetSize(width - 2, height - 2);
	frame.Background:SetPoint("CENTER", frame, "CENTER", 0, 0);

	frame.Bar:SetFrameStrata(frame:GetFrameStrata());
	frame.Bar:SetSize(width - 6, height - 6);
	frame.Bar:SetPoint("CENTER", frame, "CENTER", 0, 0);

	frame.Text:SetPoint("CENTER", 0, 0);
	frame.Text:SetSize(width - 6, height - 6);
	frame.Text:SetJustifyH("CENTER");
	frame.Text:SetWordWrap(true);
	frame.Text:SetNonSpaceWrap(true);
end

function HavenLootsFrames.SetTexture(frame, texture, r, g, b, a)
	if a == nil then a = 1 end
	frame.BarTexture:SetTexture(texture);
	frame.BarTexture:SetVertexColor(r, g, b, a);
	frame.BarTexture:SetAllPoints(frame.Bar);
	frame.Bar.texture = frame.BarTexture;
end

function HavenLootsFrames.SetBackground(frame, texture, r, g, b, a)
	if a == nil then a = 1 end
	if frame.ObjectType == "Frame" then
		frame.BackgroundTexture:SetTexture(texture);
		frame.BackgroundTexture:SetVertexColor(r, g, b, a);
		frame.BackgroundTexture:SetAllPoints(frame.Background);
		frame.Background.texture = frame.BackgroundTexture;
	elseif frame.ObjectType == "Bar" then
		frame.Background:SetStatusBarTexture(texture);
		frame.Background:SetStatusBarColor(r, g, b, a);
	end
end

function HavenLootsFrames.SetFont(frame, font, size, r, g, b, a)
	if a == nil then a = 1 end
	frame.Text:SetFont(font, size);
	frame.Text:SetTextColor(r, g, b, a);
end