local currentVersion = GetAddOnMetadata("HavenLoots", "Version");
RegisterAddonMessagePrefix("HavenLoots");
HAVEN_LOOTS_BOX_NUMBER = 10;
HavenLoots = CreateFrame("Frame", "HavenLoots", UIParent, nil);
HavenLoots.History = CreateFrame("Frame", "HavenLoots_History", HavenLoots, nil);
HavenLoots.Close = HavenLootsFrames.CreateNiceFrame(CreateFrame("button", "HavenLoots_Close", HavenLoots, nil));

HavenLoots.Loot = {};
HavenLoots.Loot[1] = HavenLootsFrames.CreateNiceFrame(CreateFrame("button", "HavenLoots_Loot_1", HavenLoots.Close, nil));
for i = 2, HAVEN_LOOTS_BOX_NUMBER do
	HavenLoots.Loot[i] = HavenLootsFrames.CreateNiceFrame(CreateFrame("button", "HavenLoots_Loot_" ..i, HavenLoots.Loot[i - 1], nil));
end
HavenLoots.Choice = {};
for i = 1, HAVEN_LOOTS_BOX_NUMBER do
	HavenLoots.Choice[i] = CreateFrame("Frame", "HavenLoots_Choice_" ..i, HavenLoots.Loot[i], nil);
	HavenLoots.Choice[i].MainSpec = HavenLootsFrames.CreateNiceBar(CreateFrame("button", "HavenLoots_Choise_" ..i .."_MainSpec", HavenLoots.Choice[i], nil));
	HavenLoots.Choice[i].OffSpec = HavenLootsFrames.CreateNiceBar(CreateFrame("button", "HavenLoots_Choise_" ..i .."_OffSpec", HavenLoots.Choice[i].MainSpec, nil));
	HavenLoots.Choice[i].OfflineAlt = HavenLootsFrames.CreateNiceBar(CreateFrame("button", "HavenLoots_Choise_" ..i .."_OfflineAlt", HavenLoots.Choice[i].OffSpec, nil));
	HavenLoots.Choice[i].Transmog = HavenLootsFrames.CreateNiceBar(CreateFrame("button", "HavenLoots_Choise_" ..i .."_Transmog", HavenLoots.Choice[i].OfflineAlt, nil));
	HavenLoots.Choice[i].Sell = HavenLootsFrames.CreateNiceBar(CreateFrame("button", "HavenLoots_Choise_" ..i .."_Sell", HavenLoots.Choice[i].Transmog, nil));
	HavenLoots.Choice[i].Pass = HavenLootsFrames.CreateNiceBar(CreateFrame("button", "HavenLoots_Choise_" ..i .."_Pass", HavenLoots.Choice[i].Sell, nil));
end

HavenLoots.Roll = {};
for i = 1, HAVEN_LOOTS_BOX_NUMBER do
	HavenLoots.Roll[i] = {
		CurrentRolls = {},
	};
	HavenLoots.Roll[i][1] = HavenLootsFrames.CreateNiceBar(CreateFrame("Frame", "HavenLoots_Roll_" ..i .."_" ..1, HavenLoots.Loot[i], nil));
	for x = 2, 40 do
		HavenLoots.Roll[i][x] = HavenLootsFrames.CreateNiceBar(CreateFrame("Frame", "HavenLoots_Roll_" ..i .."_" ..x, HavenLoots.Roll[i][x - 1], nil));
	end
end

local function IsMasterLooter(sender)
	local _, PartyID, ID = GetLootMethod();
	name = {};
	for nam in sender:gmatch("([^-]+)") do table.insert(name, nam) end
	if ID ~= nil and GetUnitName("raid" ..ID, false) == name[1] then
		return true;
	end
	if PartyID ~= nil and GetUnitName("party" ..PartyID, false) == name[1] then
		return true;
	end
	return false;
end

local function ResetAddon(self)
	self:Hide();
	for i = 1, HAVEN_LOOTS_BOX_NUMBER do
		self.Roll[i].CurrentRolls = {};
		for x = 1, 40 do
			self.Roll[i][x]:Hide();
		end
		self.Loot[i].link = nil;
		self.Loot[i]:Hide();
	end
end

local function AddToResults(name, rollType, val, itemLink)
	local itemNumber = nil;
	for i = 1, HAVEN_LOOTS_BOX_NUMBER do
		if HavenLoots.Loot[i].link ~= nil then
			if HavenLoots.Loot[i].link == itemLink then
				itemNumber = i;
			end
		end
	end
	if itemNumber == nil then return end
	if rollType ~= 6 then
		for i = 1, table.getn(HavenLoots.Roll[itemNumber].CurrentRolls) do
			if HavenLoots.Roll[itemNumber].CurrentRolls[i].val <= val then
				local data = {
					rollType = rollType,
					val = val,
					name = name,
				};
				table.insert(HavenLoots.Roll[itemNumber].CurrentRolls, i, data);
				return;
			end
		end
	end
	local data = {
		rollType = rollType,
		val = val,
		name = name,
	};
	table.insert(HavenLoots.Roll[itemNumber].CurrentRolls, data);
end

local function OnEvent(self, event, prefix, message, type, sender)
	if event == "ADDON_LOADED" then
		self.Settings = HavenLoots_LoadSettings();
		ResetAddon(self);
	elseif event == "PLAYER_LEAVING_WORLD" then
		HavenLoots_Save = self.Settings;
	elseif event == "CHAT_MSG_ADDON" then
		if IsMasterLooter(sender) then
			words = {}
			for word in message:gmatch("([^_]+)") do table.insert(words, word) end
			if words[1] == "new" then
				local cpos = 0;
				for i = 1, table.getn(self.Loot) do
					if self.Loot[i].link == words[2] then
						return;
					elseif self.Loot[i].link == nil then
						self.Loot[i].link = words[2];
						self.Loot[i].Text:SetText(words[2]);
						self.Choice[i]:Show();
						self:Show();
						self.Loot[i]:Show();
						return;
					end
				end
			elseif words[1] == "res" then
				words = {}
				for word in message:gmatch("([^_]+)") do table.insert(words, word) end
				AddToResults(words[2], tonumber(words[3]), tonumber(words[4]), words[5]);
				HavenLoots_DrawRolls(self);
			elseif words[1] == "check" then
				SendAddonMessage("HavenLoots", "ver" .."_" ..currentVersion, "RAID");
			end
		end
	elseif event == "ENCOUNTER_END" then
		ResetAddon(self);
	end
end
HavenLoots:RegisterEvent("ADDON_LOADED");
HavenLoots:RegisterEvent("PLAYER_LEAVING_WORLD");
HavenLoots:RegisterEvent("CHAT_MSG_ADDON");
HavenLoots:RegisterEvent("ENCOUNTER_END");
HavenLoots:SetScript("OnEvent", OnEvent);

SLASH_HAVENLOOTS1, SLASH_HAVENLOOTS2 = '/hl', '/havenloots';
local function ChatCommand(msg, editbox)
	if HavenLoots:IsShown() then
		HavenLoots:Hide();
	else
		HavenLoots:Show();
	end
end
SlashCmdList["HAVENLOOTS"] = ChatCommand;