local function LoadSettings(self)
	local s = HavenLoots.Settings;
	HavenLootsFrames.PositionFrames(self, "BOTTOM", self:GetParent(), "TOP", s.Width, s.TopBarHeight, 0, 0);
	HavenLootsFrames.SetTexture(self, s.Texture, s.Color.Basic[1], s.Color.Basic[2], s.Color.Basic[3], s.Color.Basic[4]);
	HavenLootsFrames.SetBackground(self, s.Texture, s.Color[self.type][1], s.Color[self.type][2], s.Color[self.type][3], s.Color[self.type][4]);
	HavenLootsFrames.SetFont(self, s.Font, s.LargeFont, s.Color[self.type][1], s.Color[self.type][2], s.Color[self.type][3], s.Color[self.type][4]);
	self.Text:SetText(self.type);
end

local function OnMouseDown(self)
	if HavenLoots.Loot[self.i].link == nil then return end
	SendAddonMessage("HavenLoots","roll" .."_" ..HavenLoots.Loot[self.i].link .."_" ..self.level, "RAID");
	HavenLoots.Choice[self.i].hasRolled = true;
	HavenLoots.Choice[self.i]:Hide();
end

local function SetUpFrame(self, type, level, i)
	self:EnableMouse(true);
	self:RegisterForClicks("LeftButtonDown");
	self:SetScript("OnMouseDown", OnMouseDown);
	self.type = type;
	self.level = level;
	self.i = i;
	LoadSettings(self);
end

local function OnEvent(self, event)
	if event == "SPELLS_CHANGED" then
		self:SetPoint("CENTER", HavenLoots.Loot[self.i], "CENTER", 0, 0);
		self:SetSize(HavenLoots.Loot[self.i]:GetSize());
		self.hasRolled = false;

		SetUpFrame(self.MainSpec, "Main Spec", 1, self.i);
		SetUpFrame(self.OffSpec, "Off Spec", 2, self.i);
		SetUpFrame(self.OfflineAlt, "Offline Alt", 3, self.i);
		SetUpFrame(self.Transmog, "Transmog", 4, self.i);
		SetUpFrame(self.Sell, "Sell", 5, self.i);
		SetUpFrame(self.Pass, "Pass", 6, self.i);
	end
end
for i = 1, HAVEN_LOOTS_BOX_NUMBER do
	HavenLoots.Choice[i].i = i;
	HavenLoots.Choice[i]:RegisterEvent("SPELLS_CHANGED");
	HavenLoots.Choice[i]:SetScript("OnEvent", OnEvent);
end