local function LoadSettings(self)
	local s = HavenLoots.Settings;
	HavenLootsFrames.PositionFrames(self, s.AnchorPoint, s.AnchorTo, s.AnchorToPoint, s.Width, s.TopBarHeight, s.XPos, s.YPos);
	HavenLootsFrames.SetTexture(self, s.Texture, s.Color.Basic[1], s.Color.Basic[2], s.Color.Basic[3], s.Color.Basic[4]);
	HavenLootsFrames.SetBackground(self, s.Texture, s.Color.Back[1], s.Color.Back[2], s.Color.Back[3], s.Color.Back[4]);
	HavenLootsFrames.SetFont(self, s.Font, s.LargeFont, s.Color.Font[1], s.Color.Font[2], s.Color.Font[3], s.Color.Font[4]);
	self.Text:SetText("Close");
end

local function MouseDown(self, button)
	if button == "RightButton" then
		self:StartMoving();
		self.isMoving = true;
	elseif button == "LeftButton" then
		HavenLoots:Hide();
	end
end

local function MouseUp(self, button)
	if self.isMoving then
		self:StopMovingOrSizing();
		self.isMoving = false;
		HavenLoots.Settings.AnchorPoint, HavenLoots.Settings.AnchorTo, HavenLoots.Settings.AnchorToPoint, HavenLoots.Settings.XPos, HavenLoots.Settings.YPos = self:GetPoint();
	end
end

local function OnEnter(self)
	GameTooltip:SetOwner(self, 'ANCHOR_TOPRIGHT');
	GameTooltip:SetText("Left click to close.\nRight click and drag to move the loot window.");
end

local function OnLeave(self)
	GameTooltip:Hide();
end

local function OnEvent(self, event)
	if event == "SPELLS_CHANGED" then
		LoadSettings(self);
		self:EnableMouse(true);
		self:RegisterForDrag("LeftButtonDown", "RightButtonDown");
		self:SetMovable(true);
		self:SetScript("OnMouseDown", MouseDown);
		self:SetScript("OnMouseUp", MouseUp);
		self:SetScript("OnEnter", OnEnter);
		self:SetScript("OnLeave", OnLeave);
	end
end
HavenLoots.Close:RegisterEvent("SPELLS_CHANGED");
HavenLoots.Close:SetScript("OnEvent", OnEvent);