local function LoadSettings(self)
	local s = HavenLoots.Settings;
	HavenLootsFrames.PositionFrames(self, "LEFT", self:GetParent(), "RIGHT", s.Width, s.TopBarHeight, 0, 0);
	HavenLootsFrames.SetTexture(self, s.Texture, s.Color.Basic[1], s.Color.Basic[2], s.Color.Basic[3], s.Color.Basic[4]);
	HavenLootsFrames.SetBackground(self, s.Texture, s.Color.Back[1], s.Color.Back[2], s.Color.Back[3], s.Color.Back[4]);
	HavenLootsFrames.SetFont(self, s.Font, s.SmallFont, s.Color.Font[1], s.Color.Font[2], s.Color.Font[3], s.Color.Font[4]);
end

local function OnUpdate(self, elapsed)
	if(IsModifiedClick('COMPAREITEMS') or (GetCVarBool('alwaysCompareItems') and not IsEquippedItem(self.itemLink))) then
		GameTooltip_ShowCompareItem();
	else
		ShoppingTooltip1:Hide();
		ShoppingTooltip2:Hide();
	end

	if(IsModifiedClick('DRESSUP')) then
		ShowInspectCursor();
	else
		ResetCursor();
	end
end

local function OnEnter(self)
	if self.link == nil then return end
	GameTooltip:SetOwner(self, 'ANCHOR_TOPRIGHT');
	GameTooltip:SetHyperlink(self.link);
	self:SetScript('OnUpdate', OnUpdate);
end

local function OnLeave(self)
	GameTooltip:Hide();
	self:SetScript('OnUpdate', nil);
end

local function OnMouseDown(self)
	if IsControlKeyDown() then
		DressUpItemLink(self.itemLink);
	elseif IsShiftKeyDown() then
		ChatEdit_InsertLink(self.itemLink);
	end
end

local function OnEvent(self, event)
	if event == "SPELLS_CHANGED" then
		LoadSettings(self);
		self:EnableMouse(true);
		self:RegisterForClicks("LeftButtonDown");
		self:SetScript("OnMouseDown", OnMouseDown);
		self:SetScript("OnEnter", OnEnter);
		self:SetScript("OnLeave", OnLeave);
	end
end
for i = 1, HAVEN_LOOTS_BOX_NUMBER do
	HavenLoots.Loot[i].link = nil;
	HavenLoots.Loot[i]:RegisterEvent("SPELLS_CHANGED");
	HavenLoots.Loot[i]:SetScript("OnEvent", OnEvent);
end