local function LoadSettings(self)
	local s = HavenLoots.Settings;
	HavenLootsFrames.PositionFrames(self, "TOP", self:GetParent(), "BOTTOM", s.Width, s.RollHeight, 0, 0);
	HavenLootsFrames.SetTexture(self, s.Texture, s.Color.Back[1], s.Color.Back[2], s.Color.Back[3], 0.5);
	HavenLootsFrames.SetBackground(self, s.Texture, 1, 1, 1, 1);
	HavenLootsFrames.SetFont(self, s.Font, s.SmallFont, s.Color.Font[1], s.Color.Font[2], s.Color.Font[3], s.Color.Font[4]);
end

local function OnEvent(self, event)
	if event == "SPELLS_CHANGED" then
		LoadSettings(self);
	end
end
for i = 1, HAVEN_LOOTS_BOX_NUMBER do
	for x = 1, 40 do
		HavenLoots.Roll[i][x].i = i;
		HavenLoots.Roll[i][x].x = x;
		HavenLoots.Roll[i][x]:RegisterEvent("SPELLS_CHANGED");
		HavenLoots.Roll[i][x]:SetScript("OnEvent", OnEvent);
	end
end

local function GetBackgroundColor(t)
	local s = HavenLoots.Settings;
	local i = "Pass";
	if t == 1 then
		i = "Main Spec";
	elseif t == 2 then
		i = "Off Spec";
	elseif t == 3 then
		i = "Offline Alt";
	elseif t == 4 then
		i = "Transmog";
	elseif t == 5 then
		i = "Sell";
	elseif t == 6 then
		i = "Pass";
	end
	return s.Color[i][1], s.Color[i][2], s.Color[i][3], s.Color[i][4];
end

function HavenLoots_DrawRolls(self)
	for i = 1, HAVEN_LOOTS_BOX_NUMBER do
		for x = 1, table.getn(HavenLoots.Roll[i].CurrentRolls) do
			local words = {}
			for word in self.Roll[i].CurrentRolls[x].name:gmatch("([^-]+)") do table.insert(words, word) end
			if self.Roll[i].CurrentRolls[x].rollType ~= 6 then
				self.Roll[i][x].Text:SetText(words[1] ..": " ..self.Roll[i].CurrentRolls[x].val - ((5 - self.Roll[i].CurrentRolls[x].rollType) * 100));
			else
				self.Roll[i][x].Text:SetText(words[1]);
			end
			self.Roll[i][x].Background:SetStatusBarColor(GetBackgroundColor(self.Roll[i].CurrentRolls[x].rollType));
			self.Roll[i][x]:Show();
		end
	end
end